Script Update (See readme for details)

This commit is contained in:
2026-04-02 10:52:25 -04:00
parent dfb68b378f
commit 1a244507fc
3 changed files with 288 additions and 133 deletions
+13 -13
View File
@@ -5,7 +5,7 @@
|-|-|-|-|-| |-|-|-|-|-|
|Hard Drive (SATA)|SATA|5.25" 4x Bay 3.5" Enclosure > 4x SATA SAS Card > PCIe Slot A|Yes|| |Hard Drive (SATA)|SATA|5.25" 4x Bay 3.5" Enclosure > 4x SATA SAS Card > PCIe Slot A|Yes||
|Solid State Drive (SATA)|SATA|5.25" 4x Bay 2.5" Enclosure > 4x SATA SAS Card > PCIe Slot A|Yes|| |Solid State Drive (SATA)|SATA|5.25" 4x Bay 2.5" Enclosure > 4x SATA SAS Card > PCIe Slot A|Yes||
|Solid State Drive (NVMe)|PCIe/M.2|5.25" 4x Bay NVMe Enclosure > MiniSAS to M.2 > M.2 Slot A|No| Not showing up in BIOS| |Solid State Drive (NVMe)|PCIe/M.2|5.25" 4x Bay NVMe Enclosure > MiniSAS to M.2 > M.2 Slot A|yes||
## Erasing ## Erasing
|Storage Type|Erase Type|Method|Implementation|Implemented?| |Storage Type|Erase Type|Method|Implementation|Implemented?|
@@ -17,16 +17,16 @@
## Logging ## Logging
|Info|Location|Log To:|Implemented?|Data|Notes| |Info|Location|Log To:|Implemented?|Data|Notes|
|-|-|-|-|-|-| |-|-|-|-|-|-|
|User|- Script Input|- Ticket<br>- Logfile|No|- Username|Probably can implement as part of the kerb auth| |User|- Script Input|- Ticket<br>- Logfile|Testing|- Username|Probably can implement as part of the kerb auth|
|Wipe Details|- Script Input|- Ticket<br>- Logfile|No|- Erase Level<br>- Device Type<br>- Device|| |Wipe Details|- Script Input|- Ticket<br>- Logfile|Testing|- Erase Level<br>- Device Type<br>- Device||
|Script Output|- Terminal Output|- Logfile|No|- All script output|Via transcribing or output redirection| |Script Output|- Terminal Output|- Logfile|Testing|- All script output|Via transcribing or output redirection|
|Machine Data|- Registry|- Ticket<br>- Logfile|No|- Machine Name<br>- Domain|HKEY_LOCAL_MACHINE\SYSTEM\ControlSet001\Control\ComputerName\ComputerName<br><br>HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\Tcpip\Parameters| |Machine Data|- Registry|- Ticket<br>- Logfile|Testing|- Machine Name<br>- Domain|HKEY_LOCAL_MACHINE\SYSTEM\ControlSet001\Control\ComputerName\ComputerName<br><br>HKEY_LOCAL_MACHINE\SYSTEM\ControlSet001\Services\Tcpip\Parameters|
|Local Users|- Registry<br>- Filesystem|- Logfile|No|- Local User List|HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion\ProfileList<br><br>c:/Users| |Local Users|- Registry<br>- Filesystem|- Logfile|Testing|- Local User List|HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion\ProfileList<br><br>c:/Users|
|Domain Users|- Registry<br>- Filesystem|- Ticket<br>- Logfile|No|- Domain User List|HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion\ProfileList<br><br>c:/Users| |Domain Users|- Registry<br>- Filesystem|- Ticket<br>- Logfile|Testing|- Domain User List|HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion\ProfileList<br><br>c:/Users|
|Last Logged On User|- Registry|- Ticket<br>- Logfile|No|- Username|HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Authentication\LogonUI| |Last Logged On User|- Registry|- Ticket<br>- Logfile|Testing|- Username|HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Authentication\LogonUI|
|Storage Info|- Other|- Ticket<br>- Logfile|No|- Serial Number<br>- SMART Data|smartctl| |Storage Info|- Other|- Ticket<br>- Logfile|Testing|- Serial Number<br>- SMART Data|smartctl|
|System Info|- Registry|- Logfile|No|- Manufacturer<br>- Model|HKEY_LOCAL_MACHINE\HARDWARE\DESCRIPTION\System\BIOS<br>Can't actually be done offline| |System Info|- Registry|- Logfile|Testing|- Manufacturer<br>- Model|HKEY_LOCAL_MACHINE\HARDWARE\DESCRIPTION\System\BIOS<br>Can't actually be done offline|
|Misc|- Misc|- Ticket<br>- Logfile|No|- Current Time<br>- Date|| |Misc|- Misc|- Ticket<br>- Logfile|Testing|- Current Time<br>- Date||
@@ -35,6 +35,6 @@
|-|-|-|-|-| |-|-|-|-|-|
Erasure Environment|Setup Alpine Linux Environment with SquashFS/No Persistence|Lightweight Linux Distro that can be loaded into RAM and be edited.<br>Avoids wiping USB but also can be used on any machine and customized.|Yes|| Erasure Environment|Setup Alpine Linux Environment with SquashFS/No Persistence|Lightweight Linux Distro that can be loaded into RAM and be edited.<br>Avoids wiping USB but also can be used on any machine and customized.|Yes||
|Scripted Erase Tool|Write a script to guide the erase process|Allows for ease of use, and ensures consistent workflow<br>Can also tie in user auth, logging, etc|Yes|Done via bash scripting in erase_drive.sh| |Scripted Erase Tool|Write a script to guide the erase process|Allows for ease of use, and ensures consistent workflow<br>Can also tie in user auth, logging, etc|Yes|Done via bash scripting in erase_drive.sh|
|User Authentication|Implement user authentication|For Auditing, Logging, connection to network shares, etc.|No|Probably kerb auth via krb5 |User Authentication|Implement user authentication|For Auditing, Logging, connection to network shares, etc.|Testing|Probably kerb auth via krb5
|Logging|Implement logging|For auditing purposes|No|Record user, drive serial, grab user list (if windows/unix drive), grab hostname, record script inputs| |Logging|Implement logging|For auditing purposes|Testing|Record user, drive serial, grab user list (if windows/unix drive), grab hostname, record script inputs|
|Ticket Notes|Add ticket note through script|To keep keyword searchable records associated with a ticket|No|Send email to Otobo with small details such as level, hostname, serial, etc<br>Might involve policy changes for when a ticket should be created.| |Ticket Notes|Add ticket note through script|To keep keyword searchable records associated with a ticket|No|Send email to Otobo with small details such as level, hostname, serial, etc<br>Might involve policy changes for when a ticket should be created.|
+253 -120
View File
@@ -1,64 +1,104 @@
#!/bin/bash #!/bin/bash
#!/usr/bin/env bash #!/usr/bin/env bash
## Get NetID
## Mount \\reinstallbackups
## Start logging ## Start logging
## Get NetID
### Auth
## Mount \\reinstallbackup
## Get Ticket Number (optional) ## Get Ticket Number (optional)
### Check if Directory with Ticket Number exists ### Check if Directory with Ticket Number exists
#### Warn User if it doesn't #### Warn User if it doesn't
## ##
exec 3>&1 1>"$LOGFILE" 2>&1 start_time="$(date '+%Y-%m-%d_%H:%M:%S')"
log="/tmp/log_$start_time"
log_x="/tmp/log_x_$start_time"
exec 3>&1 1>"$log_x" 2>&1
set -x
cleanup () { loginput() {
echo "SPECIAL EXIT" echo "$*" >&3;
pcie_disable echo "[INPUT] $(date '+%H:%M:%S') $*" >> "$log";
trap - INT
kill -INT "$$"
} }
trap cleanup SIGINT loginfo() {
echo "$*" >&3;
echo "[INFO] $(date '+%H:%M:%S') $*" >> "$log";
}
logwarn() {
echo "$*" >&3;
echo "[WARNING] $(date '+%H:%M:%S') $*" >> "$log";
}
logerror() {
echo "$*" >&3;
echo "[ERROR] $(date '+%H:%M:%S') $*" >> "$log";
}
confirm_message () { confirm_message () {
local typed= local typed=
while [[ ! $typed = "$2" ]]; while [[ ! $typed = "$2" ]];
do do
echo "$1" loginput "$1"
read -r typed read -r typed
done done
} }
catch_sigint () {
logwarn "Signal Interrupt initiated. Stopping script."
cleanup
trap - INT
kill -INT "$$"
}
cleanup () {
loginfo "Cleaning up."
pcie_disable
if [[ ! $dirname =~ ^\s*$ ]];
then
loginfo "Unmounting drives."
umount "/mnt/reinstallbackups"
#rmdir "/mnt/reinstallbackups"
umount "/mnt/decs"
#rmdir "/mnt/decs"
fi
}
trap catch_sigint SIGINT
get_netid () { get_netid () {
netid= netid=
while [[ $netid =~ ^\s*$ ]]; while [[ $netid =~ ^\s*$ ]];
do do
echo "Enter netid: " loginfo "Enter netid: "
read -r netid read -r netid
if [[ $netid =~ ^\s*$ ]]; if [[ $netid =~ ^\s*$ ]];
then then
echo "Your netid cannot be blank. Enter netid: " logwarn "Your netid cannot be blank."
loginfo "Enter netid: "
else else
authenticate_egr authenticate_egr "$netid"
fi fi
done done
clear clear
} }
authenticate_egr (){ authenticate_egr (){
kinit "$netid" kinit "$1"
local ret_value="$?" local ret_value=$(kinit "$1" &> /dev/null; echo $?)
if [[ ! $ret_value = "0" ]] if [[ ! $ret_value = "0" ]]
then then
netid= netid=
case $ret_value in case $ret_value in
"1") "1")
echo "Error when authenticating. Please see above issue, and try again." logwarn "Error when authenticating. Please see above issue, and try again."
;; ;;
*) *)
echo "Unspecified error." logerror "Unspecified error."
cleanup
;; ;;
esac esac
fi fi
@@ -66,38 +106,67 @@ authenticate_egr (){
get_ticket () { get_ticket () {
ticket_number= ticket_number=
echo "Enter ticket number: " loginfo "Enter ticket number: "
read -r ticket_number read -r ticket_number
if [[ ! $ticket_number =~ ^\s*$ ]]; if [[ ! $ticket_number =~ ^\s*$ ]];
then then
local ret_value=$(ls | grep -q -E "^$ticket_number"; echo $?) mkdir /mnt/reinstallbackups
mount -t cifs -o user="$netid",sec=krb5i "//reinstallbackups/reinstallbackups" /mnt/reinstallbackups
local ret_value=$(ls /mnt/reinstallbackups | grep -q -E "^$ticket_number" &> /dev/null; echo $?)
if [[ ! $ret_value = "0" ]]; if [[ ! $ret_value = "0" ]];
then then
printf "WARNING: Backup does not exist in \\\\reinstallbackups\reinstallbackups\\$ticket_number!\n" logwarn "WARNING: Backup does not exist in //reinstallbackups/reinstallbackups/$ticket_number!"
fi fi
umount "/mnt/reinstallbackups"
#rmdir "/mnt/reinstallbackups"
else else
sleep 1 ticket_number="UNKNWN"
logwarn "Starting with no ticket number specified."
logwarn "Cannot check for backup in //reinstallbackups/reinstallbackups."
fi fi
} }
mount_drive () { mount_remote () {
sleep 1 mkdir /mnt/decs
{
mount -t cifs -o user="$netid",sec=krb5i "//decs/decs/support/dban_logs" /mnt/decs
dirname=
if [[ ! $ticket_number =~ ^\s*$ ]];
then
dirname="UNKNWN-$start_time"
else
dirname="$ticket_number"
fi
if [ ! -e "/mnt/decs/$dirname" ];
then
mkdir "/mnt/decs/$dirname"
fi
mv "$log" "/mnt/decs/$dirname/log_$ticket_number\_$start_time"
mv "$log_x" "/mnt/decs/$dirname/log_$ticket_number\_$start_time"
log="/mnt/decs/$dirname/log_$ticket_number\_$start_time"
log_x="/mnt/decs/$dirname/log_$ticket_number\_$start_time"
rm "/tmp/log_$start_time"
rm "/tmp/log_x_$start_time"
} || {
logerror "Failed to mount remote DECS drive. Stopping"
cleanup
}
} }
get_eraselevel () { get_eraselevel () {
eraselevel= eraselevel=
echo "What level of erase are you performing on the drive? (0 = baseline, 1 = secure erase, 2 = decommission):" loginfo "What level of erase are you performing on the drive? (0 = baseline, 1 = secure erase, 2 = decommission):"
echo "Type 'help' for an explanation of each level." loginfo "Type 'help' for an explanation of each level."
read -r eraselevel read -r eraselevel
while [[ ! $eraselevel = "0" ]] && [[ ! $eraselevel = "1" ]] && [[ ! $eraselevel = "2" ]]; while [[ ! $eraselevel = "0" ]] && [[ ! $eraselevel = "1" ]] && [[ ! $eraselevel = "2" ]];
do do
if [[ $eraselevel = "help" ]]; if [[ $eraselevel = "help" ]];
then then
echo "Level 0 / Baseline: clears the partitions of the drive. Data can still be recovered but this is the optimal level for simple reuse." loginfo "Level 0 / Baseline: clears the partitions of the drive. Data can still be recovered but this is the optimal level for simple reuse."
echo "Level 1 / Secure Erase: HDD: Scrambles the data on the drive over 3 passes. SSD: Sends a signal to the drive to forget the encryption key, making it unread -rable." loginfo "Level 1 / Secure Erase: HDD: Scrambles the data on the drive over 3 passes. SSD: Sends a signal to the drive to forget the encryption key, making it unreadrable."
echo "Level 2 / decommission: Scrambles the data on the drive over 7 passes. Afterward, put the drive in the bin near the Hardware office to have it destroyed." loginfo "Level 2 / decommission: Scrambles the data on the drive over 7 passes. Afterward, put the drive in the bin near the Hardware office to have it destroyed."
else else
echo "Invalid level, correct values can be 0, 1, or 2" logwarn "Invalid level, correct values can be 0, 1, or 2"
fi fi
read -r eraselevel read -r eraselevel
done done
@@ -105,18 +174,18 @@ get_eraselevel () {
get_devicetype () { get_devicetype () {
devicetype= devicetype=
echo "What is the device type? (0 = HDD_SATA, 1 = SSD_NVME, 2 = SSD_SATA):" loginfo "What is the device type? (0 = HDD_SATA, 1 = SSD_NVME, 2 = SSD_SATA):"
echo "Type 'help' for an explanation of each type." loginfo "Type 'help' for an explanation of each type."
read -r devicetype read -r devicetype
while [[ ! $devicetype = "0" ]] && [[ ! $devicetype = "1" ]] && [[ ! $devicetype = "2" ]]; while [[ ! $devicetype = "0" ]] && [[ ! $devicetype = "1" ]] && [[ ! $devicetype = "2" ]];
do do
if [[ $devicetype = "help" ]]; if [[ $devicetype = "help" ]];
then then
echo "HDD_SATA: Spinning disk platters on a SATA connection. Typically 3.5 in or 2.5 in." loginfo "HDD_SATA: Spinning disk platters on a SATA connection. Typically 3.5 in or 2.5 in."
echo "SSD_SATA: Solid State drive on a SATA connection. Typically 2.5 in." loginfo "SSD_SATA: Solid State drive on a SATA connection. Typically 2.5 in."
echo "SSD_NVME: Solid State drive on a M.2 connection. Looks like a small PCB." loginfo "SSD_NVME: Solid State drive on a M.2 connection. Looks like a small PCB."
else else
echo "Invalid type, correct values can be 0 = HDD_SATA, 1 = SSD_NVME, 2 = SSD_SATA." logwarn "Invalid type, correct values can be 0 = HDD_SATA, 1 = SSD_NVME, 2 = SSD_SATA."
fi fi
read -r devicetype read -r devicetype
done done
@@ -134,7 +203,8 @@ get_devicetype () {
;; ;;
*) *)
echo "Unspecified error." logerror "Unspecified error when getting device."
cleanup
;; ;;
esac esac
} }
@@ -142,17 +212,17 @@ get_devicetype () {
get_device () { get_device () {
device= device=
pcie_enable pcie_enable
echo "Printing current attached devices..." loginfo "loginfoing current attached devices..."
echo "" loginfo ""
if [[ $devicetype = "HDD_SATA" ]] || [[ $devicetype = "SSD_SATA" ]]; if [[ $devicetype = "HDD_SATA" ]] || [[ $devicetype = "SSD_SATA" ]];
then then
lsblk | grep -E '^NAME|^sd' loginfo "$(lsblk | grep -E '^NAME|^sd')"
elif [[ $devicetype = "SSD_NVME" ]]; elif [[ $devicetype = "SSD_NVME" ]];
then then
lsblk | grep -E '^NAME|^nvme' loginfo "$(lsblk | grep -E '^NAME|^nvme')"
fi fi
echo "" loginfo ""
echo "Which is the device from this list? (Type 'help' for help.)" loginfo "Which is the device from this list? (Type 'help' for help.)"
while [[ $device =~ ^\s*$ ]]; while [[ $device =~ ^\s*$ ]];
do do
@@ -166,11 +236,11 @@ verify_device (){
do do
if [[ $device = "help" ]]; if [[ $device = "help" ]];
then then
echo "The UNIX filesystem thinks of storage devices as directories, which are under /dev/" loginfo "The UNIX filesystem thinks of storage devices as directories, which are under /dev/"
echo "If you have a SATA connection, you will be looking for sd{a-z}." loginfo "If you have a SATA connection, you will be looking for sd{a-z}."
echo "If you have a NVME connection, you will be looking for nvme0n{0-9}." loginfo "If you have a NVME connection, you will be looking for nvme0n{0-9}."
else else
echo "Invalid format, device should follow naming conventions. (i.e. sd{a-z}, nvme0n{0-9})" logwarn "Invalid format, device should follow naming conventions. (i.e. sd{a-z}, nvme0n{0-9})"
fi fi
read -r device read -r device
done done
@@ -178,64 +248,122 @@ verify_device (){
then then
if [[ $device =~ ^nvme0n[0-9]$ ]]; if [[ $device =~ ^nvme0n[0-9]$ ]];
then then
echo "Device was specified to be a SATA HDD or SSD, but a NVME device was chosen." logwarn "Device was specified to be a SATA HDD or SSD, but a NVME device was chosen."
device= device=
fi fi
elif [[ $devicetype = "SSD_NVME" ]]; elif [[ $devicetype = "SSD_NVME" ]];
then then
if [[ $device =~ ^sd[a-z]$ ]]; if [[ $device =~ ^sd[a-z]$ ]];
then then
echo "Device was specified to be a NVME SSD, but a SATA device was chosen. Please ensure the device is plugged into the motherboard via PCIe slot and not SATA." logwarn "Device was specified to be a NVME SSD, but a SATA device was chosen. Please ensure the device is plugged into the motherboard via PCIe slot and not SATA."
device= device=
fi fi
fi fi
if [ -e "/dev/${device}" ]; then if [ -e "/dev/$device" ]; then
echo "Picking device /dev/${device}." loginfo "Picking device /dev/$device."
else else
echo "/dev/${device} does not exist, please ensure you are typing the device name correctly." logwarn "/dev/$device does not exist, please ensure you are typing the device name correctly."
device= device=
fi fi
} }
make_infolog () {
infolog="/mnt/decs/$dirname/info_$ticket_number\_$start_time"
{
echo "DETAILS"
echo "Start Time: $start_time"
echo "NetID: $netid"
echo "Ticket number: $ticket_number"
echo ""
echo "ERASE DETAILS"
echo "Type/Device: $devicetype : $device"
echo "Erase Level: $eraselevel"
echo ""
echo "DEVICE DETAILS"
lsblk -O | grep "NAME\|$device"
echo ""
sudo smartctl -i /dev/nvme0n1
echo ""
} >> "$infolog"
while [ -e "/mnt/wintmnt" ];
do
Sleep 5
done
mkdir "/mnt/winmnt"
local ret_value=$(mount -t ntfs "/dev/$device" /mnt/winmt &> /dev/null; echo $?)
if [[ $ret_value = "0" ]]
then
mount -t ntfs "/dev/$device" /mnt/winmt
local ret_value2=$(find /mnt/winmnt/ -ipath "*System32/config" -not -ipath "*Windows.old*" &> /dev/null; echo $?)
if [[ $ret_value2 = "0" ]]
then
winpath=$(find /mnt/winmnt/ -ipath "*System32/config" -not -ipath "*Windows.old*")
{
echo "WINDOWS DETAILS"
echo ""
echo "HOSTNAME"
hivexregedit --export --unsafe-printable-strings --prefix \\HKEY_LOCAL_MACHINE\\SOFTWARE "$winpath/SYSTEM" '\Microsoft\Windows\ControlSet001\Control\ComputerName\ComputerName'
echo ""
echo "DOMAIN"
hivexregedit --export --unsafe-printable-strings --prefix \\HKEY_LOCAL_MACHINE\\SOFTWARE "$winpath/SYSTEM" '\Microsoft\Windows\ControlSet001\Services\Tcpip\Parameters'
echo ""
echo "LOGON DETAILS"
hivexregedit --export --unsafe-printable-strings --prefix \\HKEY_LOCAL_MACHINE\\SOFTWARE "$winpath/SOFTWARE" '\Microsoft\Windows\CurrentVersion\Authentication\LogonUI'
echo ""
hivexregedit --export --unsafe-printable-strings --prefix \\HKEY_LOCAL_MACHINE\\SOFTWARE "$winpath/SOFTWARE" '\Microsoft\Windows NT\CurrentVersion\ProfileList'
echo ""
ls "$(find /mnt/winmnt/ -type d -ipath "*Windows/Users")"
echo ""
} >> "$infolog"
fi
else
logerror "Failed to mount local Windows directory."
cleanup
fi
echo "END OF LOG" >> "$infolog"
}
erase_device_lv0 () { erase_device_lv0 () {
echo "Wiping partition tables of ${devicetype} : ${device}." loginfo "Wiping partition tables of $devicetype : $device."
local ret_value=$(sgdisk -g -Z /dev/"$device" &> /dev/null; echo $?) local ret_value=$(sgdisk -g -Z /dev/"$device" &> /dev/null; echo $?)
if [[ ! $ret_value = "0" ]] if [[ ! $ret_value = "0" ]]
then then
case $ret_value in case $ret_value in
"1") "1")
echo "There was an issue with the argument. Ensure you typed the drive name correctly." logerror "There was an issue with the argument. Ensure you typed the drive name correctly."
;; ;;
"2") "2")
echo "An error occurred while read -ring the partition table." logerror "An error occurred while reading the partition table."
;; ;;
"3") "3")
echo "Non-GPT disk detected and no -g option, but operation requires a write action." logerror "Non-GPT disk detected and no -g option, but operation requires a write action."
;; ;;
"4") "4")
echo "An error prevented saving changes." logerror "An error prevented saving changes."
;; ;;
"5") "5")
echo "An error occurred while read -ring standard input." logerror "An error occurred while readring standard input."
;; ;;
"8") "8")
echo "Disk replication operation (-R) failed." logerror "Disk replication operation (-R) failed."
;; ;;
*) *)
echo "Unspecified error." logerror "Unspecified error."
;; ;;
esac esac
cleanup
else else
echo "Partition tables wiped. Device is read -ry for reuse." loginfo "Partition tables wiped. Device is readry for reuse."
fi fi
} }
@@ -245,91 +373,94 @@ erase_device_lv1 () {
#SSD NVMe = nvme secure erase #SSD NVMe = nvme secure erase
if [[ $devicetype = "HDD_SATA" ]] && [[ ! $eraselevel = "2" ]]; if [[ $devicetype = "HDD_SATA" ]] && [[ ! $eraselevel = "2" ]];
then then
echo "Running 3-Pass DOD Short on ${devicetype} : ${device}." loginfo "Running 3-Pass DOD Short on ${devicetype} : ${device}."
echo "This may take a while!" loginfo "This may take a while!"
local ret_value=$(nwipe -m dodshort --autonuke --nogui /dev/"$device" &> /dev/null; echo $?) local ret_value=$(nwipe -m dodshort --autonuke --nogui /dev/"$device" &> /dev/null; echo $?)
if [[ ! $ret_value = "0" ]] if [[ ! $ret_value = "0" ]]
then then
case $ret_value in case $ret_value in
"-1") "-1")
echo "Unspecified error while nwiping disk." logerror "Unspecified error while nwiping disk."
;; ;;
*) *)
echo "Unspecified error while nwiping disk." logerror "Unspecified error while nwiping disk."
;; ;;
esac esac
cleanup
else else
echo "Finished wiping data with nwipe." loginfo "Finished wiping data with nwipe."
fi fi
elif [[ $devicetype = "SSD_SATA" ]]; elif [[ $devicetype = "SSD_SATA" ]];
then then
echo "Running hdparm format on ${devicetype} : ${device}." loginfo "Running hdparm format on $devicetype : $device."
echo "Setting security pass to NULL." loginfo "Setting security pass to NULL."
#Set the password of the drive to NULL #Set the password of the drive to NULL
local ret_value=$(hdparm --user-master m --security-set-pass NULL /dev/"$device" &> /dev/null; echo $?) local ret_value=$(hdparm --user-master m --security-set-pass NULL /dev/"$device" &> /dev/null; echo $?)
if [[ ! $ret_value = "0" ]]; if [[ ! $ret_value = "0" ]];
then then
hdparm_check_error "${ret_value}" hdparm_check_error "$ret_value"
echo "Failed to set password of drive. Attempting to continue." logwarn "Failed to set password of drive. Attempting to continue."
else else
echo "Set password of drive to NULL." loginfo "Set password of drive to NULL."
fi fi
#Attempt a secure erase. #Attempt a secure erase.
local ret_value=$(hdparm --user-master m --security-erase-enhanced NULL /dev/"$device" &> /dev/null; echo $?) local ret_value=$(hdparm --user-master m --security-erase-enhanced NULL /dev/"$device" &> /dev/null; echo $?)
if [[ ! $ret_value = "0" ]]; if [[ ! $ret_value = "0" ]];
then then
hdparm_check_error "${ret_value}" hdparm_check_error "$ret_value"
else logwarn "Enhanced Secure Erase failed. This is not unexpected depending on the drive type."
echo "Enhanced secure erase failed. This is not unexpected depending on the drive type." loginfo "Attempting Secure Erase instead."
echo "Attempting normal erase instead."
#Attempt a secure erase, less enhanced. #Attempt a secure erase, less enhanced.
local ret_value=$(hdparm --user-master m --security-erase NULL /dev/"$device" &> /dev/null; echo $?) local ret_value2=$(hdparm --user-master m --security-erase NULL /dev/"$device" &> /dev/null; echo $?)
if [[ ! $ret_value2 = "0" ]];
if [[ ! $ret_value = "0" ]];
then then
hdparm_check_error "${ret_value}" hdparm_check_error "$ret_value2"
logerror "Failed to Secure Erase. Please contact your supervisor."
cleanup
else else
echo "Failed to secure erase. Please contact your supervisor." loginfo "Secure Erase success."
fi fi
else
loginfo "Enhanced Secure Erase success."
fi fi
elif [[ $devicetype = "SSD_NVME" ]]; elif [[ $devicetype = "SSD_NVME" ]];
then then
echo "Running nvme_cli format on ${devicetype} : ${device}." loginfo "Running nvme_cli format on $devicetype : $device."
#Erase using nvme cli to send secure erase command to drop the crypto stuff. #Erase using nvme cli to send secure erase command to drop the crypto stuff.
local ret_value=$(nvme format --force -r -s 2 /dev/"$device" &> /dev/null; echo $?) local ret_value=$(nvme format --force -r -s 2 /dev/"$device" &> /dev/null; echo $?)
if [[ ! $ret_value = "0" ]] if [[ ! $ret_value = "0" ]]
then then
echo "Failed to cryptographically erase drive, blanket erasing instead." logwarn "Failed to cryptographically erase drive, blanket erasing instead."
#Sad, can't do it. Blank out drive instead using the drive controller. #Sad, can't do it. Blank out drive instead using the drive controller.
local ret_value=$(nvme format --force -r -s 1 /dev/"$device" &> /dev/null; echo $?) local ret_value=$(nvme format --force -r -s 1 /dev/"$device" &> /dev/null; echo $?)
if [[ ! $ret_value = "0" ]] if [[ ! $ret_value = "0" ]]
then then
echo "Failed to cryptographically erase or blanket erase. Please contact your supervisor." logerror "Failed to cryptographically erase or blanket erase. Please contact your supervisor."
cleanup
else else
echo "Blanket erased drive." loginfo "Blanket erased drive."
fi fi
else else
echo "Cryptographically erased drive." loginfo "Cryptographically erased drive."
fi fi
else else
echo "There was an issue with the device type: ${devicetype}. Ensure you typed the drive name correctly." logerror "There was an issue with the device type: $devicetype. Ensure you typed the drive name correctly."
cleanup
fi fi
} }
erase_device_lv2 () { erase_device_lv2 () {
#7-Pass DOD Wipe through nwipe. #7-Pass DOD Wipe through nwipe.
echo "Running 7-Pass DOD on ${devicetype} : ${device}." loginfo "Running 7-Pass DOD on $devicetype : $device."
echo "This may take a while!" loginfo "This may take a while!"
local ret_value=$(nwipe -m dod --autonuke --nogui /dev/"$device" &> /dev/null; echo $?) local ret_value=$(nwipe -m dod --autonuke --nogui /dev/"$device" &> /dev/null; echo $?)
@@ -337,43 +468,44 @@ erase_device_lv2 () {
then then
case $ret_value in case $ret_value in
"-1") "-1")
echo "Unspecified error while nwiping disk." logerror "Unspecified error while nwiping disk."
;; ;;
*) *)
echo "Unspecified error while nwiping disk." logerror "Unspecified error while nwiping disk."
;; ;;
esac esac
cleanup
else else
echo "Finished wiping data with nwipe." loginfo "Finished wiping data with nwipe."
echo "Please put device in decommission bin in the hardware room." loginfo "Please put device in decommission bin in the hardware room."
fi fi
} }
hdparm_check_error () { hdparm_check_error () {
case $1 in case $1 in
"1") "1")
echo "Operation not permitted." logerror "Operation not permitted."
;; ;;
"2") "2")
echo "No such file or directory." logerror "No such file or directory."
;; ;;
"5") "5")
echo "I/O error." logerror "I/O error."
;; ;;
"16") "16")
echo "Device or resource busy." logerror "Device or resource busy."
;; ;;
"22") "22")
echo "Invalid argument." logerror "Invalid argument."
;; ;;
*) *)
echo "Unspecified error." logerror "Unspecified error."
;; ;;
esac esac
} }
@@ -381,37 +513,37 @@ hdparm_check_error () {
#Rescan for PCIe devices #Rescan for PCIe devices
pcie_enable (){ pcie_enable (){
echo 1 > /sys/bus/pci/rescan echo 1 > /sys/bus/pci/rescan
echo "Enabled PCIe card, sleeping for 5 seconds." loginfo "Enabled PCIe card, sleeping for 5 seconds."
sleep 5 sleep 5
} }
#Remove the PCIe NVMe read -rer #Remove the PCIe NVMe readrer
pcie_disable (){ pcie_disable (){
echo 1 > /sys/bus/pci/devices/0000:02:00.0/remove echo 1 > /sys/bus/pci/devices/0000:02:00.0/remove
echo "Disabled PCIe card." loginfo "Disabled PCIe card."
} }
main (){ main (){
get_netid get_netid
get_ticket_number get_ticket
check_backup mount_remote
echo "By running this script, you are confirming that it has been two weeks past the date written on the slip attached to the storage device. DO NOT erase the device before two weeks have passed." loginfo "By running this script, you are confirming that it has been two weeks past the date written on the slip attached to the storage device. DO NOT erase the device before two weeks have passed."
confirm_message "Please type 'confirm' to acknowledge you have read -r this and that it has been two weeks." "confirm" confirm_message "Please type 'confirm' to acknowledge you have read this and that it has been two weeks." "confirm"
get_eraselevel #sets $eraselevel to 0-2 based on how to erase. Higher levels include lower levels. get_eraselevel #sets $eraselevel to 0-2 based on how to erase. Higher levels include lower levels.
get_devicetype #sets $devicetype to HDD_SATA/SSD_SATA/SSD_NVME get_devicetype #sets $devicetype to HDD_SATA/SSD_SATA/SSD_NVME
get_device #sets $device to one of the /dev/xyz devices. get_device #sets $device to one of the /dev/xyz devices.
clear make_infolog #Logs a bunch of details to a info log file from the system.
echo "Starting process for erasing ${devicetype} : ${device} with erase level ${eraselevel}." loginfo "Starting process for erasing $devicetype : $device with erase level $eraselevel."
if [[ $eraselevel = "1" ]] || [[ $eraselevel = "2" ]]; if [[ $eraselevel = "1" ]] || [[ $eraselevel = "2" ]];
then then
local randomconf=$(shuf -i 10000-99999 -n 1) local randomconf=$(shuf -i 10000-99999 -n 1)
confirm_message "This level is destructive and irreversible. Please type ${randomconf} to continue" "${randomconf}" confirm_message "This level is destructive and irreversible. Please type $randomconf to continue" "$randomconf"
else else
confirm_message "Please type 'confirm' to begin." "confirm" confirm_message "Please type 'confirm' to begin." "confirm"
fi fi
@@ -419,30 +551,31 @@ main (){
case $eraselevel in case $eraselevel in
"0") "0")
erase_device_lv0 #Wipe partition erase_device_lv0 #Wipe partition
;; ;;
"1") "1")
erase_device_lv1 #Secure Erase erase_device_lv1 #Secure Erase
erase_device_lv0 #Wipe partition erase_device_lv0 #Wipe partition
;; ;;
"2") "2")
erase_device_lv1 #Secure Erase (skips nwipe) erase_device_lv1 #Secure Erase (skips nwipe for HDDs)
erase_device_lv2 #7-Pass nwipe erase_device_lv2 #7-Pass nwipe
erase_device_lv0 #Wipe partition erase_device_lv0 #Wipe partition
;; ;;
*) *)
echo "Invalid Erase Level" logerror "Invalid Erase Level"
cleanup
;; ;;
esac esac
sleep 3 sleep 3
echo "Finished erasing ${devicetype} : ${device} with erase level ${eraselevel}." loginfo "Finished erasing $devicetype : $device with erase level $eraselevel."
pcie_disable cleanup
} }
main main
+22
View File
@@ -0,0 +1,22 @@
#!/bin/bash
#!/usr/bin/env bash
netid=
loginfo "Enter netid: "
read -r netid
while [[ $netid =~ ^\s*$ ]];
do
logwarn "Your netid cannot be blank."
loginfo "Enter netid: "
done
ret_value=$(kinit "$1" &> /dev/null; echo $?)
while [[ ! ${kinit "$1" &> /dev/null; echo $?} = "0" ]]
do
logwarn "Error when authenticating. Please see above issue, and try again."
ret_value=$(kinit "$1" &> /dev/null; echo $?)
done
mkdir /mnt/decs
mount -t cifs -o user="$netid",sec=krb5i "//decs/decs/support/dban_logs" /mnt/decs
echo "test" > "/mnt/decs/test.txt"